--[[ include used code ]]
require "defines"
require "config"

require "scripts.configTools"
require "scripts.playersButton"

require "interface"

--[[ local funcs ]]
local function getPluginSettingsTable()
	local settings = {
		cb_onCreateGui = "onCreateGui",-- callback interface_functionName when creating the SuperTopGui
		cb_onRemoveGui = "onRemoveGui",-- callback interface_functionName when removing the SuperTopGui
		cb_onUpdateGui = "onUpdateGui",-- callback interface_functionName when updating the SuperTopGui
		settingsBtn_name = MOD_SETTINGS_BUTTON-- name of the plugin-Settings button in "settings+" --> "Plugin settings";;;NOT the caption of the button!
	}
	return settings
end

local function installPlugIn()
	local remote_interfaceName = "ThunderGui"
	local remote_functionName = "registerPlugin"
	local interface = remote.interfaces[remote_interfaceName]--get interface
	if interface then--check if the interface is valid
		if interface[remote_functionName] then--check if the function is valid
			if glob.cfg.printMode and game.players[1] then
				game.players[1].print( string.format( "installing %s plugin...", MOD_PLUGIN_INTERFACE ) ) 
			end
			remote.call( remote_interfaceName, remote_functionName, MOD_PLUGIN_INTERFACE, getPluginSettingsTable() )
		end
	end
end

--[ event onInit ]
game.oninit( function()
	if not MOD_ENABLED then return end --if the settings say the mod is disabled then we stop here
	--$$ initialize mod variables
	sf_check_global_cfg()
	sf_reset_allPlayerCfgs()
	--$$ register our plugin at ThunderGui
	installPlugIn()
end)

--[ event onLoad ]
game.onload( function()
	--$$ if (by version change) glog.cfg resets, reset player cfg(s)-too
	if sf_check_global_cfg() then
		--$$ reset player configs too and re-install
		sf_reset_allPlayerCfgs()
		installPlugIn()
	end
end)

--[ event onplayercreated ]
game.onevent(defines.events.onplayercreated, 
function(event)
	--$$ give the new player a config
	sf_check_playerCfg(event.playerindex)
end)

