
function sf_reset_cfg(cfg)--$$ can be used to create/refresh glob.cfg and (future) playerData[id].cfg (playerSpecific Options)
	if #game.players == 1 and glob.cfg and glob.cfg.developerMode == true then
		game.players[1].print( string.format( "%s: loading configuration defaults", MY_INTERFACE_NAME ) )
	end
	--$$ create cfg table ... should already be done!! (can't change it throug this function's variable otherwise)
	--cfg = {}

	cfg.version = MOD_VERSION
	cfg.viewPlayerSettings = SHOW_PLAYER_SETTINGS
	cfg.showPlayersButtton = SHOW_PLAYERS_BUTTON
	cfg.privateTableView = PRIVATE_TABLE_VIEW
	cfg.printMode = DEVELOPER_MODE
end 

function sf_check_global_cfg()
	--$$ Cake
	--$$ (re-)Load config (if running game is using old mod-settings)
	if (not glob.cfg or glob.cfg.version == nil or glob.cfg.version ~= MOD_VERSION) then  --undefined or version change
		--$$ Perfection = performance ? Lie : Pie // end of pun \0
		if glob.cfg and ( glob.cfg.developerMode == true or DEVELOPER_MODE == true ) then
			--$$ we get here when glob.cfg is defined but: ( version is undefined or different from expectations ) and developerMode defined and true
			for _, player in pairs(game.players) do
				player.print( string.format( 
						"%s: mod-version change detected(%s). Loading configuration defaults(%s)",
						MOD_PLUGIN_INTERFACE, 
						sf_VersionString(glob.cfg.version), sf_VersionString(MOD_VERSION) ) )
			end
		end
		glob.cfg = {}
		sf_reset_cfg(glob.cfg)
		return true
	end
	return false
end

function sf_VersionString(version)
	if version == nil then return "version: unkown" end
	local version_prime = math.floor(version)
	local version_second = (version-version_prime)*10 
	local version_third = (version_second- math.floor(version_second))*10
	return string.format("version: %d.%d.%d", version_prime, math.floor(version_second), version_third )
end

function sf_reset_playerCfg(player_cfg)
	--$$ create cfg table ... should already be done!! 
	--player_cfg = {}

	player_cfg.viewPlayerSettings = glob.cfg.viewPlayerSettings
	player_cfg.showPlayersButtton = glob.cfg.showPlayersButtton
	player_cfg.privateTableView = glob.cfg.privateTableView
	player_cfg.printMode = glob.cfg.printMode
end

function sf_reset_allPlayerCfgs()
	if glob.playerCfg == nil then
		glob.playerCfg = {}
	end
	for PIndex, player in pairs(game.players) do
		if glob.playerCfg[PIndex] == nil then
			glob.playerCfg[PIndex] = {}
		end
		sf_reset_playerCfg( glob.playerCfg[PIndex] )
	end
end


function sf_check_playerCfg(playerindex)
	if glob.playerCfg == nil then
		glob.playerCfg = {}
	end
	if glob.playerCfg[playerindex] == nil then
		glob.playerCfg[playerindex] = {}
		sf_reset_playerCfg( glob.playerCfg[playerindex] )
	end
end
