
local function add_bottom_frame(guiFrame, playerindex)
	local myFlow = guiFrame.add( { type="flow", direction="horizontal" } )
	myFlow.style.minimalwidth = 320
	myFlow.style.toppadding = 8
	local myElement = myFlow.add( { type= "button", name= "tfrRefreshPage", caption="back" } )
	myElement.style.fontcolor = { r=1,g=1,b=0 }
	myFlow.add( { type= "button", name= "tfrClose", caption="close" } )
end

local function create_thunderBox(player, playerindex)
	return player.gui.center.add( { type="frame", name="thunderBox", 
		caption = "Thunder box", style="tms_frame_compact", direction="vertical"} )
end

local function open_or_renew_thunderBox(player, playerindex)
   local myFrame = player.gui.center.thunderBox
 	if myFrame then
      myFrame.destroy();
   end
   return create_thunderBox(player, playerindex)
end

local function get_thunderBox_minWidth()
	local remote_interfaceName = "ThunderGui"
	local remote_functionName = "getCfgProp"
	local config_propertyName = "thunderBox_minimalWidth"
	local interface = remote.interfaces[remote_interfaceName]--get interface
	if interface then--check if the interface is valid
		if interface[remote_functionName] then--check if the function is valid
			return remote.call( remote_interfaceName, remote_functionName, config_propertyName )
		end
	end
	return 360
end

local function get_safeMultiplayrMode()
	local remote_interfaceName = "ThunderGui"
	local remote_functionName = "getCfgProp"
	local config_propertyName = "safeMultiplayerMode"
	local interface = remote.interfaces[remote_interfaceName]--get interface
	if interface then--check if the interface is valid
		if interface[remote_functionName] then--check if the function is valid
			return remote.call( remote_interfaceName, remote_functionName, config_propertyName )
		end
	end
	return 360
end

function tf_pB_settings_openUpdate(player, playerindex)
	local myFrame = open_or_renew_thunderBox(player, playerindex)
	local thunderBox_minimalWidth = get_thunderBox_minWidth()
	local safeMultiplayerMode = get_safeMultiplayrMode()

	local myElement = myFrame.add( { type= "label", caption= string.format( "-->Plugin settings:-->%s", MOD_PLUGIN_INTERFACE ) } )
	myElement.style.font= "default-frame"
	myElement.style.minimalwidth = thunderBox_minimalWidth

	--$$ get selected config
	local selectedConfig = ""
	local viewPlayerSettings = false
	local cfg = glob.playerCfg[playerindex]
	if cfg and ( cfg.viewPlayerSettings or (safeMultiplayerMode and playerindex > 1 ))then
		viewPlayerSettings = true
		selectedConfig = "player "..tostring(playerindex)
	else
		cfg = glob.cfg
		selectedConfig = "global"
	end 

	local myCompactFlow = myFrame.add( { type="flow", direction="vertical", style="tms_flow_compact" } )

	local myHorizontalFlow = myCompactFlow.add( { type= "flow", direction= "horizontal", style= "tms_flow_compact" } )
	myHorizontalFlow.style.minimalwidth = thunderBox_minimalWidth
		myElement = myHorizontalFlow.add( { type= "button", name= "mtbnSetsPlyr", style= "tms_button", caption= "player" } )
	if playerindex <= 1 or not safeMultiplayerMode then
		myElement = myHorizontalFlow.add( { type= "button", name= "mtbnSetsGlob", style= "tms_button", caption= "global" } )
	else 
		myElement = myHorizontalFlow.add( { type= "button", style= "tms_buttonInactive", caption= "global" } )
	end

	local mySettingsFlow = myCompactFlow.add( { type= "frame", direction= "vertical", style="tms_frameAlpha" } )
	mySettingsFlow.style.bottompadding = 10

	local myElement = mySettingsFlow.add( {type= "label", style= "tms_label",
			caption= string.format( "Settings from: %q", selectedConfig ) } )
	myElement.style.minimalwidth = thunderBox_minimalWidth
	myElement.style.leftpadding = 0
	myElement.style.toppadding = 0
	myElement.style.bottompadding = 10
	myElement.style.font= "default-frame"
	myElement.style.fontcolor = { r=0.7,g=0.7,b=1}

	myHorizontalFlow = mySettingsFlow.add( { type= "flow", direction= "horizontal" } )
	myHorizontalFlow.style.minimalwidth = thunderBox_minimalWidth
	myHorizontalFlow.style.leftpadding = 10
	myElement = myHorizontalFlow.add( { type= "button", name= "mptbnTglShowBtn", style= "tms_button", caption= "toggle" } )
		--myElement.style.fontcolor = { r=1,g=0,b=0 }
		myElement = myHorizontalFlow.add( {type= "label", style= "tms_label",
				caption= string.format( "showPlayersButtton = %s", tostring(cfg.showPlayersButtton) ) } )
		myElement.style.bottompadding = 10

	if not viewPlayerSettings then
		myHorizontalFlow = mySettingsFlow.add( { type= "flow", direction= "horizontal" } )
		myHorizontalFlow.style.minimalwidth = thunderBox_minimalWidth
		myHorizontalFlow.style.leftpadding = 10
		myElement = myHorizontalFlow.add( { type= "button", name= "mptbnTglPvtMode", style= "tms_button", caption= "toggle" } )
			--myElement.style.fontcolor = { r=1,g=0,b=0 }
			myElement = myHorizontalFlow.add( {type= "label", style= "tms_label",
					caption= string.format( "privateTableView = %s", tostring(cfg.privateTableView) ) } )
			myElement.style.bottompadding = 10

		myHorizontalFlow = mySettingsFlow.add( { type= "flow", direction= "horizontal" } )
		myHorizontalFlow.style.minimalwidth = thunderBox_minimalWidth
		myHorizontalFlow.style.leftpadding = 10
		myElement = myHorizontalFlow.add( { type= "button", name= "mptbnTglPrintMode", style= "tms_button", caption= "toggle" } )
			--myElement.style.fontcolor = { r=1,g=0,b=0 }
			myElement = myHorizontalFlow.add( {type= "label", style= "tms_label",
					caption= string.format( "printMode = %s", tostring(cfg.printMode) ) } )
			myElement.style.bottompadding = 10
	end
	
	--[[
	myElement = mySettingsFlow.add( { type= "button", name= "tbnShowHidePlayers", 
			caption= string.format( "Show/Hide Players+ button", MOD_PLUGIN_INTERFACE ) } )
	myElement.style.minimalwidth = thunderBox_minimalWidth-4
	myElement.style.fontcolor = { r=1,g=0.5,b=0}
	--]]

	add_bottom_frame( myFrame, playerindex, true)
end

